]> Git Repo - u-boot.git/blame - .azure-pipelines.yml
CI: Drop some jobs we didn't really utilize
[u-boot.git] / .azure-pipelines.yml
CommitLineData
d2e680fa 1variables:
38a9840d 2 windows_vm: windows-2019
b0a23a60 3 ubuntu_vm: ubuntu-22.04
24291741 4 macos_vm: macOS-12
453c3fb4 5 ci_runner_image: trini/u-boot-gitlab-ci-runner:jammy-20230804-25Aug2023
bf275222
BM
6 # Add '-u 0' options for Azure pipelines, otherwise we get "permission
7 # denied" error when it tries to "useradd -m -u 1001 vsts_azpcontainer",
8 # since our $(ci_runner_image) user is not root.
9 container_option: -u 0
10 work_dir: /u
d2e680fa 11
67d3e67d
TR
12stages:
13- stage: testsuites
14 jobs:
d2e680fa
BM
15 - job: tools_only_windows
16 displayName: 'Ensure host tools build for Windows'
17 pool:
18 vmImage: $(windows_vm)
d2e680fa 19 steps:
437e70f7 20 - powershell: |
1ce892cb 21 (New-Object Net.WebClient).DownloadFile("https://github.com/msys2/msys2-installer/releases/download/2021-06-04/msys2-base-x86_64-20210604.sfx.exe", "sfx.exe")
d2e680fa
BM
22 displayName: 'Install MSYS2'
23 - script: |
437e70f7 24 sfx.exe -y -o%CD:~0,2%\
f8e7670f
TR
25 %CD:~0,2%\msys64\usr\bin\bash -lc " "
26 %CD:~0,2%\msys64\usr\bin\bash -lc "pacman --noconfirm -Syuu"
27 %CD:~0,2%\msys64\usr\bin\bash -lc "pacman --noconfirm -Syuu"
d2e680fa
BM
28 displayName: 'Update MSYS2'
29 - script: |
d9612f44 30 %CD:~0,2%\msys64\usr\bin\bash -lc "pacman --noconfirm --needed -Sy make gcc bison flex diffutils openssl-devel libgnutls-devel libutil-linux-devel"
d2e680fa
BM
31 displayName: 'Install Toolchain'
32 - script: |
d948c898 33 echo make tools-only_defconfig tools-only > build-tools.sh
f7faddf6 34 %CD:~0,2%\msys64\usr\bin\bash -lc "bash build-tools.sh"
d2e680fa
BM
35 displayName: 'Build Host Tools'
36 env:
37 # Tell MSYS2 we need a POSIX emulation layer
38 MSYSTEM: MSYS
39 # Tell MSYS2 not to ‘cd’ our startup directory to HOME
40 CHERE_INVOKING: yes
bf275222 41
7b4116d4
TR
42 - job: tools_only_macOS
43 displayName: 'Ensure host tools build for macOS X'
44 pool:
45 vmImage: $(macos_vm)
46 steps:
d9612f44 47 - script: brew install make ossp-uuid
7b4116d4
TR
48 displayName: Brew install dependencies
49 - script: |
d948c898 50 gmake tools-only_config tools-only \
7b4116d4
TR
51 HOSTCFLAGS="-I/usr/local/opt/[email protected]/include" \
52 HOSTLDFLAGS="-L/usr/local/opt/[email protected]/lib" \
53 -j$(sysctl -n hw.logicalcpu)
54 displayName: 'Perform tools-only build'
55
bb9b9c1e
TR
56 - job: check_for_new_CONFIG_symbols_outside_Kconfig
57 displayName: 'Check for new CONFIG symbols outside Kconfig'
c1a7de57
TR
58 pool:
59 vmImage: $(ubuntu_vm)
60 container:
61 image: $(ci_runner_image)
62 options: $(container_option)
63 steps:
bb9b9c1e
TR
64 # If grep succeeds and finds a match the test fails as we should
65 # have no matches.
66 - script: git grep -E '^#[[:blank:]]*(define|undef)[[:blank:]]*CONFIG_'
a03efb6f
TR
67 :^doc/ :^arch/arm/dts/ :^scripts/kconfig/lkc.h
68 :^include/linux/kconfig.h :^tools/ && exit 1 || exit 0
c1a7de57 69
e9cc7029
HS
70 - job: docs
71 displayName: 'Build documentation'
4eb0fc99
HS
72 pool:
73 vmImage: $(ubuntu_vm)
74 container:
75 image: $(ci_runner_image)
76 options: $(container_option)
77 steps:
836049d6
HS
78 - script: |
79 virtualenv -p /usr/bin/python3 /tmp/venvhtml
80 . /tmp/venvhtml/bin/activate
81 pip install -r doc/sphinx/requirements.txt
8a6414d1 82 make htmldocs KDOC_WERROR=1
e9cc7029 83 make infodocs
4eb0fc99 84
bf275222
BM
85 - job: maintainers
86 displayName: 'Ensure all configs have MAINTAINERS entries'
87 pool:
88 vmImage: $(ubuntu_vm)
89 container:
90 image: $(ci_runner_image)
91 options: $(container_option)
92 steps:
93 - script: |
1b21842e 94 ./tools/buildman/buildman --maintainer-check || exit 0
bf275222
BM
95
96 - job: tools_only
562ed115 97 displayName: 'Ensure host tools and env tools build'
bf275222
BM
98 pool:
99 vmImage: $(ubuntu_vm)
100 container:
101 image: $(ci_runner_image)
102 options: $(container_option)
103 steps:
104 - script: |
105 make tools-only_config tools-only -j$(nproc)
562ed115 106 make mrproper
bf275222
BM
107 make tools-only_config envtools -j$(nproc)
108
109 - job: utils
7261833f 110 displayName: 'Run binman, buildman, dtoc, Kconfig and patman testsuites'
bf275222
BM
111 pool:
112 vmImage: $(ubuntu_vm)
113 steps:
114 - script: |
b6d4e085
TR
115 cat << "EOF" > build.sh
116 cd $(work_dir)
bf275222
BM
117 git config --global user.name "Azure Pipelines"
118 git config --global user.email [email protected]
b6d4e085 119 git config --global --add safe.directory $(work_dir)
bf275222 120 export USER=azure
26a426a1 121 virtualenv -p /usr/bin/python3 /tmp/venv
bf275222 122 . /tmp/venv/bin/activate
38229b55 123 pip install -r test/py/requirements.txt
f586cdae 124 pip install -r tools/buildman/requirements.txt
48f792e3 125 export UBOOT_TRAVIS_BUILD_DIR=/tmp/tools-only
bf275222
BM
126 export PYTHONPATH=${UBOOT_TRAVIS_BUILD_DIR}/scripts/dtc/pylibfdt
127 export PATH=${UBOOT_TRAVIS_BUILD_DIR}/scripts/dtc:${PATH}
48f792e3 128 ./tools/buildman/buildman -T0 -o ${UBOOT_TRAVIS_BUILD_DIR} -w --board tools-only
b6d4e085 129 set -ex
bf275222
BM
130 ./tools/binman/binman --toolpath ${UBOOT_TRAVIS_BUILD_DIR}/tools test
131 ./tools/buildman/buildman -t
132 ./tools/dtoc/dtoc -t
6bb74de7 133 ./tools/patman/patman test
7261833f 134 make O=${UBOOT_TRAVIS_BUILD_DIR} testconfig
bf275222
BM
135 EOF
136 cat build.sh
137 # We cannot use "container" like other jobs above, as buildman
138 # seems to hang forever with pre-configured "container" environment
139 docker run -v $PWD:$(work_dir) $(ci_runner_image) /bin/bash $(work_dir)/build.sh
140
6cfd09d4
T
141 - job: nokia_rx51_test
142 displayName: 'Run tests for Nokia RX-51 (aka N900)'
143 pool:
144 vmImage: $(ubuntu_vm)
145 container:
146 image: $(ci_runner_image)
147 options: $(container_option)
148 steps:
149 - script: |
ce0f745c
T
150 mkdir nokia_rx51_tmp
151 ln -s /opt/nokia/u-boot-gen-combined nokia_rx51_tmp/
152 ln -s /opt/nokia/qemu-n900.tar.gz nokia_rx51_tmp/
153 ln -s /opt/nokia/kernel_2.6.28-20103103+0m5_armel.deb nokia_rx51_tmp/
154 ln -s /opt/nokia/libc6_2.5.1-1eglibc27+0m5_armel.deb nokia_rx51_tmp/
155 ln -s /opt/nokia/busybox_1.10.2.legal-1osso30+0m5_armel.deb nokia_rx51_tmp/
156 ln -s /opt/nokia/qemu-system-arm nokia_rx51_tmp/
11934281 157 export PATH=/opt/gcc-13.2.0-nolibc/arm-linux-gnueabi/bin:$PATH
6cfd09d4
T
158 test/nokia_rx51_test.sh
159
642e51ad
SG
160 - job: pylint
161 displayName: Check for any pylint regressions
162 pool:
163 vmImage: $(ubuntu_vm)
164 container:
165 image: $(ci_runner_image)
166 options: $(container_option)
167 steps:
168 - script: |
b6d4e085 169 git config --global --add safe.directory $(work_dir)
642e51ad
SG
170 export USER=azure
171 pip install -r test/py/requirements.txt
f586cdae 172 pip install -r tools/buildman/requirements.txt
e47bbf7e 173 pip install asteval pylint==2.12.2 pyopenssl
642e51ad
SG
174 export PATH=${PATH}:~/.local/bin
175 echo "[MASTER]" >> .pylintrc
176 echo "load-plugins=pylint.extensions.docparams" >> .pylintrc
48f792e3
TR
177 export UBOOT_TRAVIS_BUILD_DIR=/tmp/tools-only
178 ./tools/buildman/buildman -T0 -o ${UBOOT_TRAVIS_BUILD_DIR} -w --board tools-only
b6d4e085 179 set -ex
642e51ad
SG
180 pylint --version
181 export PYTHONPATH=${UBOOT_TRAVIS_BUILD_DIR}/scripts/dtc/pylibfdt
182 make pylint_err
183
441a3d0a
SG
184 - job: check_for_pre_schema_tags
185 displayName: 'Check for pre-schema driver model tags'
186 pool:
187 vmImage: $(ubuntu_vm)
188 container:
189 image: $(ci_runner_image)
190 options: $(container_option)
191 steps:
192 # If grep succeeds and finds a match the test fails as we should
193 # have no matches.
194 - script: git grep u-boot,dm- -- '*.dts*' && exit 1 || exit 0
195
c21a5286
SG
196 - job: check_packing_of_python_tools
197 displayName: 'Check we can package the Python tools'
198 pool:
199 vmImage: $(ubuntu_vm)
200 container:
201 image: $(ci_runner_image)
202 options: $(container_option)
203 steps:
204 - script: make pip
205
67d3e67d
TR
206- stage: test_py
207 jobs:
bf275222
BM
208 - job: test_py
209 displayName: 'test.py'
210 pool:
211 vmImage: $(ubuntu_vm)
212 strategy:
213 matrix:
214 sandbox:
215 TEST_PY_BD: "sandbox"
9aeac898
TR
216 sandbox_asan:
217 TEST_PY_BD: "sandbox"
218 OVERRIDE: "-a ASAN"
219 TEST_PY_TEST_SPEC: "version"
0219d014
TR
220 sandbox_clang:
221 TEST_PY_BD: "sandbox"
d7e0678c 222 OVERRIDE: "-O clang-16"
9aeac898
TR
223 sandbox_clang_asan:
224 TEST_PY_BD: "sandbox"
225 OVERRIDE: "-O clang-16 -a ASAN"
226 TEST_PY_TEST_SPEC: "version"
1aa168ca
SG
227 sandbox_nolto:
228 TEST_PY_BD: "sandbox"
229 BUILD_ENV: "NO_LTO=1"
bf275222
BM
230 sandbox_spl:
231 TEST_PY_BD: "sandbox_spl"
afb26ba9 232 TEST_PY_TEST_SPEC: "test_ofplatdata or test_handoff or test_spl"
a31eff30
SG
233 sandbox_vpl:
234 TEST_PY_BD: "sandbox_vpl"
8b609878 235 TEST_PY_TEST_SPEC: "vpl or test_spl"
6c914e42
SG
236 sandbox_noinst:
237 TEST_PY_BD: "sandbox_noinst"
238 TEST_PY_TEST_SPEC: "test_ofplatdata or test_handoff or test_spl"
bf275222
BM
239 sandbox_flattree:
240 TEST_PY_BD: "sandbox_flattree"
9cea4797
SG
241 sandbox_trace:
242 TEST_PY_BD: "sandbox"
243 BUILD_ENV: "FTRACE=1 NO_LTO=1"
244 TEST_PY_TEST_SPEC: "trace"
61cad8da 245 OVERRIDE: "-a CONFIG_TRACE=y -a CONFIG_TRACE_EARLY=y -a CONFIG_TRACE_EARLY_SIZE=0x01000000 -a CONFIG_TRACE_BUFFER_SIZE=0x02000000"
bfb2a7fb
SG
246 coreboot:
247 TEST_PY_BD: "coreboot"
248 TEST_PY_ID: "--id qemu"
249 TEST_PY_TEST_SPEC: "not sleep"
bf275222
BM
250 evb_ast2500:
251 TEST_PY_BD: "evb-ast2500"
252 TEST_PY_ID: "--id qemu"
b24087ae
JS
253 evb_ast2600:
254 TEST_PY_BD: "evb-ast2600"
255 TEST_PY_ID: "--id qemu"
15e30106
KA
256 vexpress_ca9x4:
257 TEST_PY_BD: "vexpress_ca9x4"
258 TEST_PY_ID: "--id qemu"
bf275222
BM
259 integratorcp_cm926ejs:
260 TEST_PY_BD: "integratorcp_cm926ejs"
261 TEST_PY_ID: "--id qemu"
262 TEST_PY_TEST_SPEC: "not sleep"
bf275222
BM
263 qemu_arm:
264 TEST_PY_BD: "qemu_arm"
265 TEST_PY_TEST_SPEC: "not sleep"
bf275222
BM
266 qemu_arm64:
267 TEST_PY_BD: "qemu_arm64"
268 TEST_PY_TEST_SPEC: "not sleep"
a21e1123
MV
269 qemu_m68k:
270 TEST_PY_BD: "M5208EVBE"
271 TEST_PY_ID: "--id qemu"
272 TEST_PY_TEST_SPEC: "not sleep and not efi"
273 OVERRIDE: "-a CONFIG_M68K_QEMU=y -a ~CONFIG_MCFTMR"
e35c2a8f
DS
274 qemu_malta:
275 TEST_PY_BD: "malta"
276 TEST_PY_ID: "--id qemu"
277 TEST_PY_TEST_SPEC: "not sleep and not efi"
278 qemu_maltael:
279 TEST_PY_BD: "maltael"
280 TEST_PY_ID: "--id qemu"
281 TEST_PY_TEST_SPEC: "not sleep and not efi"
282 qemu_malta64:
283 TEST_PY_BD: "malta64"
284 TEST_PY_ID: "--id qemu"
285 TEST_PY_TEST_SPEC: "not sleep and not efi"
286 qemu_malta64el:
287 TEST_PY_BD: "malta64el"
288 TEST_PY_ID: "--id qemu"
289 TEST_PY_TEST_SPEC: "not sleep and not efi"
bf275222
BM
290 qemu_ppce500:
291 TEST_PY_BD: "qemu-ppce500"
292 TEST_PY_TEST_SPEC: "not sleep"
a379d330
BM
293 qemu_riscv32:
294 TEST_PY_BD: "qemu-riscv32"
295 TEST_PY_TEST_SPEC: "not sleep"
bf275222
BM
296 qemu_riscv64:
297 TEST_PY_BD: "qemu-riscv64"
298 TEST_PY_TEST_SPEC: "not sleep"
49fb28a4
BM
299 qemu_riscv32_spl:
300 TEST_PY_BD: "qemu-riscv32_spl"
301 TEST_PY_TEST_SPEC: "not sleep"
49fb28a4
BM
302 qemu_riscv64_spl:
303 TEST_PY_BD: "qemu-riscv64_spl"
304 TEST_PY_TEST_SPEC: "not sleep"
bf275222
BM
305 qemu_x86:
306 TEST_PY_BD: "qemu-x86"
307 TEST_PY_TEST_SPEC: "not sleep"
bf275222
BM
308 qemu_x86_64:
309 TEST_PY_BD: "qemu-x86_64"
310 TEST_PY_TEST_SPEC: "not sleep"
0e125756
MV
311 r2dplus_i82557c:
312 TEST_PY_BD: "r2dplus"
313 TEST_PY_ID: "--id i82557c_qemu"
314 r2dplus_pcnet:
315 TEST_PY_BD: "r2dplus"
316 TEST_PY_ID: "--id pcnet_qemu"
317 r2dplus_rtl8139:
318 TEST_PY_BD: "r2dplus"
319 TEST_PY_ID: "--id rtl8139_qemu"
320 r2dplus_tulip:
321 TEST_PY_BD: "r2dplus"
322 TEST_PY_ID: "--id tulip_qemu"
0e60b3a7
BM
323 sifive_unleashed_sdcard:
324 TEST_PY_BD: "sifive_unleashed"
325 TEST_PY_ID: "--id sdcard_qemu"
326 sifive_unleashed_spi-nor:
327 TEST_PY_BD: "sifive_unleashed"
328 TEST_PY_ID: "--id spi-nor_qemu"
f7c6ee7f
MS
329 xilinx_zynq_virt:
330 TEST_PY_BD: "xilinx_zynq_virt"
bf275222
BM
331 TEST_PY_ID: "--id qemu"
332 TEST_PY_TEST_SPEC: "not sleep"
bf275222
BM
333 xilinx_versal_virt:
334 TEST_PY_BD: "xilinx_versal_virt"
335 TEST_PY_ID: "--id qemu"
336 TEST_PY_TEST_SPEC: "not sleep"
bf275222
BM
337 xtfpga:
338 TEST_PY_BD: "xtfpga"
339 TEST_PY_ID: "--id qemu"
340 TEST_PY_TEST_SPEC: "not sleep"
bf275222
BM
341 steps:
342 - script: |
343 cat << EOF > test.sh
344 set -ex
345 # make environment variables available as tests are running inside a container
346 export WORK_DIR="${WORK_DIR}"
347 export TEST_PY_BD="${TEST_PY_BD}"
348 export TEST_PY_ID="${TEST_PY_ID}"
349 export TEST_PY_TEST_SPEC="${TEST_PY_TEST_SPEC}"
0219d014 350 export OVERRIDE="${OVERRIDE}"
1aa168ca 351 export BUILD_ENV="${BUILD_ENV}"
bf275222
BM
352 EOF
353 cat << "EOF" >> test.sh
354 # the below corresponds to .gitlab-ci.yml "before_script"
355 cd ${WORK_DIR}
bd181a24 356 git config --global --add safe.directory ${WORK_DIR}
85ae52b9 357 git clone --depth=1 https://source.denx.de/u-boot/u-boot-test-hooks /tmp/uboot-test-hooks
bf275222
BM
358 ln -s travis-ci /tmp/uboot-test-hooks/bin/`hostname`
359 ln -s travis-ci /tmp/uboot-test-hooks/py/`hostname`
bf275222
BM
360 grub-mkimage --prefix=\"\" -o ~/grub_x86.efi -O i386-efi normal echo lsefimmap lsefi lsefisystab efinet tftp minicmd
361 grub-mkimage --prefix=\"\" -o ~/grub_x64.efi -O x86_64-efi normal echo lsefimmap lsefi lsefisystab efinet tftp minicmd
49fb28a4 362 if [[ "${TEST_PY_BD}" == "qemu-riscv32_spl" ]]; then
0a8239af
BM
363 wget -O - https://github.com/riscv-software-src/opensbi/releases/download/v1.2/opensbi-1.2-rv-bin.tar.xz | tar -C /tmp -xJ;
364 export OPENSBI=/tmp/opensbi-1.2-rv-bin/share/opensbi/ilp32/generic/firmware/fw_dynamic.bin;
49fb28a4 365 fi
0e60b3a7 366 if [[ "${TEST_PY_BD}" == "qemu-riscv64_spl" ]] || [[ "${TEST_PY_BD}" == "sifive_unleashed" ]]; then
0a8239af
BM
367 wget -O - https://github.com/riscv-software-src/opensbi/releases/download/v1.2/opensbi-1.2-rv-bin.tar.xz | tar -C /tmp -xJ;
368 export OPENSBI=/tmp/opensbi-1.2-rv-bin/share/opensbi/lp64/generic/firmware/fw_dynamic.bin;
49fb28a4 369 fi
bf275222
BM
370 # the below corresponds to .gitlab-ci.yml "script"
371 cd ${WORK_DIR}
4e32fed4 372 export UBOOT_TRAVIS_BUILD_DIR=/tmp/${TEST_PY_BD};
9cea4797
SG
373 if [ -n "${BUILD_ENV}" ]; then
374 export ${BUILD_ENV};
375 fi
f586cdae 376 pip install -r tools/buildman/requirements.txt
7ec1255c 377 tools/buildman/buildman -o ${UBOOT_TRAVIS_BUILD_DIR} -w -E -W -e --board ${TEST_PY_BD} ${OVERRIDE}
9e0f5eab
HS
378 cp ~/grub_x86.efi ${UBOOT_TRAVIS_BUILD_DIR}/
379 cp ~/grub_x64.efi ${UBOOT_TRAVIS_BUILD_DIR}/
380 cp /opt/grub/grubriscv64.efi ${UBOOT_TRAVIS_BUILD_DIR}/grub_riscv64.efi
9e0f5eab
HS
381 cp /opt/grub/grubaa64.efi ${UBOOT_TRAVIS_BUILD_DIR}/grub_arm64.efi
382 cp /opt/grub/grubarm.efi ${UBOOT_TRAVIS_BUILD_DIR}/grub_arm.efi
0e60b3a7
BM
383 # create sdcard / spi-nor images for sifive unleashed using genimage
384 if [[ "${TEST_PY_BD}" == "sifive_unleashed" ]]; then
385 mkdir -p root;
386 cp ${UBOOT_TRAVIS_BUILD_DIR}/spl/u-boot-spl.bin .;
387 cp ${UBOOT_TRAVIS_BUILD_DIR}/u-boot.itb .;
388 rm -rf tmp;
389 genimage --inputpath . --config board/sifive/unleashed/genimage_sdcard.cfg;
390 cp images/sdcard.img ${UBOOT_TRAVIS_BUILD_DIR}/;
391 rm -rf tmp;
392 genimage --inputpath . --config board/sifive/unleashed/genimage_spi-nor.cfg;
393 cp images/spi-nor.img ${UBOOT_TRAVIS_BUILD_DIR}/;
394 fi
bfb2a7fb 395 if [[ "${TEST_PY_BD}" == "coreboot" ]]; then
c60e6a24 396 wget -O - "https://drive.google.com/uc?id=1uJ2VkUQ8czWFZmhJQ90Tp8V_zrJ6BrBH&export=download" |xz -dc >${UBOOT_TRAVIS_BUILD_DIR}/coreboot.rom;
bfb2a7fb
SG
397 wget -O - "https://drive.google.com/uc?id=149Cz-5SZXHNKpi9xg6R_5XITWohu348y&export=download" >cbfstool;
398 chmod a+x cbfstool;
399 ./cbfstool ${UBOOT_TRAVIS_BUILD_DIR}/coreboot.rom add-flat-binary -f ${UBOOT_TRAVIS_BUILD_DIR}/u-boot.bin -n fallback/payload -c LZMA -l 0x1110000 -e 0x1110000;
400 fi
5d80a1a9
TR
401 virtualenv -p /usr/bin/python3 /tmp/venv
402 . /tmp/venv/bin/activate
403 pip install -r test/py/requirements.txt
be566abd 404 pip install pytest-azurepipelines
5d6f0535 405 export PATH=/opt/qemu/bin:/tmp/uboot-test-hooks/bin:${PATH};
bf275222 406 export PYTHONPATH=/tmp/uboot-test-hooks/py/travis-ci;
4080d097 407 # "${var:+"-k $var"}" expands to "" if $var is empty, "-k $var" if not
542ae523 408 ./test/py/test.py -ra -o cache_dir="$UBOOT_TRAVIS_BUILD_DIR"/.pytest_cache --bd ${TEST_PY_BD} ${TEST_PY_ID} ${TEST_PY_TEST_SPEC:+"-k ${TEST_PY_TEST_SPEC}"} --build-dir "$UBOOT_TRAVIS_BUILD_DIR" --report-dir "$UBOOT_TRAVIS_BUILD_DIR";
bf275222 409 # the below corresponds to .gitlab-ci.yml "after_script"
6049d516 410 rm -rf /tmp/uboot-test-hooks /tmp/venv
bf275222
BM
411 EOF
412 cat test.sh
413 # make current directory writeable to uboot user inside the container
414 # as sandbox testing need create files like spi flash images, etc.
415 # (TODO: clean up this in the future)
416 chmod 777 .
e22ec9c6
ANY
417 # Filesystem tests need extra docker args to run
418 set --
419 if [[ "${TEST_PY_BD}" == "sandbox" ]]; then
420 # mount -o loop needs the loop devices
421 if modprobe loop; then
422 for d in $(find /dev -maxdepth 1 -name 'loop*'); do
423 set -- "$@" --device $d:$d
424 done
425 fi
426 # Needed for mount syscall (for guestmount as well)
427 set -- "$@" --cap-add SYS_ADMIN
428 # Default apparmor profile denies mounts
429 set -- "$@" --security-opt apparmor=unconfined
430 fi
1aaaf60d 431 # Some tests using libguestfs-tools need the fuse device to run
e22ec9c6 432 docker run "$@" --device /dev/fuse:/dev/fuse -v $PWD:$(work_dir) $(ci_runner_image) /bin/bash $(work_dir)/test.sh
58b35850 433 retryCountOnTaskFailure: 2 # QEMU may be too slow, etc.
bf275222 434
67d3e67d
TR
435- stage: world_build
436 jobs:
bf275222 437 - job: build_the_world
04f7e953 438 timeoutInMinutes: 0 # Use the maximum allowed
bf275222
BM
439 displayName: 'Build the World'
440 pool:
441 vmImage: $(ubuntu_vm)
442 strategy:
443 # Use almost the same target division in .travis.yml, only merged
11232139 444 # 3 small build jobs (arc/microblaze/xtensa) into one.
bf275222 445 matrix:
9aeac898
TR
446 am33xx_at91_kirkwood_mvebu_omap:
447 BUILDMAN: "am33xx at91_kirkwood mvebu omap -x siemens"
448 amlogic_bcm_boundary_engicam_siemens_technexion_oradex:
449 BUILDMAN: "amlogic bcm boundary engicam siemens technexion toradex -x mips"
450 arm_nxp_minus_imx:
451 BUILDMAN: "freescale -x powerpc,m68k,imx,mx"
bf275222 452 imx:
9aeac898
TR
453 BUILDMAN: "mx imx -x boundary,engicam,technexion,toradex"
454 rk:
455 BUILDMAN: "rk"
456 sunxi:
457 BUILDMAN: "sunxi"
05f958f8 458 powerpc:
9aeac898
TR
459 BUILDMAN: "powerpc"
460 arm_catch_all:
461 BUILDMAN: "arm -x aarch64,am33xx,at91,bcm,ls1,kirkwood,mvebu,omap,rk,siemens,mx,sunxi,technexion,toradex"
bf275222 462 aarch64_catch_all:
9aeac898
TR
463 BUILDMAN: "aarch64 -x amlogic,bcm,engicam,imx,ls1,ls2,lx216,mvebu,rk,siemens,sunxi,toradex"
464 everything_but_arm_and_powerpc:
465 BUILDMAN: "-x arm,powerpc"
bf275222
BM
466 steps:
467 - script: |
468 cat << EOF > build.sh
469 set -ex
470 cd ${WORK_DIR}
471 # make environment variables available as tests are running inside a container
472 export BUILDMAN="${BUILDMAN}"
bd181a24 473 git config --global --add safe.directory ${WORK_DIR}
f586cdae 474 pip install -r tools/buildman/requirements.txt
bf275222
BM
475 EOF
476 cat << "EOF" >> build.sh
477 if [[ "${BUILDMAN}" != "" ]]; then
478 ret=0;
d7713ad3 479 tools/buildman/buildman -o /tmp -PEWM ${BUILDMAN} ${OVERRIDE} || ret=$?;
dd5c954e 480 if [[ $ret -ne 0 ]]; then
b52f5a19 481 tools/buildman/buildman -o /tmp -seP ${BUILDMAN};
bf275222
BM
482 exit $ret;
483 fi;
484 fi
485 EOF
486 cat build.sh
487 docker run -v $PWD:$(work_dir) $(ci_runner_image) /bin/bash $(work_dir)/build.sh
This page took 0.192746 seconds and 4 git commands to generate.